Loading...
Searching...
No Matches
juce::ComponentMovementWatcher Class Referenceabstract

## Detailed Description

An object that watches for any movement of a component or any of its parent components.

This makes it easy to check when a component is moved relative to its top-level peer window. The normal Component::moved() method is only called when a component moves relative to its immediate parent, and sometimes you want to know if any of components higher up the tree have moved (which of course will affect the overall position of all their sub-components).

It also includes a callback that lets you know when the top-level peer is changed.

This class is used by specialised components like WebBrowserComponent because they need to keep their custom windows in the right place and respond to changes in the peer.

The documentation for this class was generated from the following file:

- juce_gui_basics/layout/juce_ComponentMovementWatcher.h

Inheritance diagram for juce::ComponentMovementWatcher:

## Public Member Functions

| ComponentMovementWatcher (Component *componentToWatch)
| Creates a ComponentMovementWatcher to watch a given target component.
| ~ComponentMovementWatcher () override
| Destructor.
virtual void | componentMovedOrResized (bool wasMoved, bool wasResized)=0
| This callback happens when the component that is being watched is moved relative to its top-level peer window, or when it is resized.
virtual void | componentPeerChanged ()=0
| This callback happens when the component's top-level peer is changed.
virtual void | componentVisibilityChanged ()=0
| This callback happens when the component's visibility state changes, possibly due to one of its parents being made visible or invisible.
Component * | getComponent () const noexcept
| Returns the component that's being watched.
void | componentParentHierarchyChanged (Component &) override
| Called to indicate that the component's parents have changed.
void | componentMovedOrResized (Component &, bool wasMoved, bool wasResized) override
| Called when the component's position or size changes.
void | componentBeingDeleted (Component &) override
| Called when the component is in the process of being deleted.
void | componentVisibilityChanged (Component &) override
| Called when the component is made visible or invisible.
Public Member Functions inherited from juce::ComponentListener
virtual | ~ComponentListener ()=default
| Destructor.
virtual void | componentBroughtToFront (Component &component)
| Called when the component is brought to the top of the z-order.
virtual void | componentChildrenChanged (Component &component)
| Called when the component has children added or removed, or their z-order changes.
virtual void | componentNameChanged (Component &component)
| Called when the component's name is changed.
virtual void | componentEnablementChanged (Component &component)
virtual void | componentPainted (Component &component, const ComponentPaintDiagnostics &diagnostics)
| Called each time the component is painted into a context.

## Constructors and Destructors

## ComponentMovementWatcher()

juce::ComponentMovementWatcher::ComponentMovementWatcher | ( | Component * | componentToWatch | ) |

Creates a ComponentMovementWatcher to watch a given target component.

Referenced by componentVisibilityChanged().

## ~ComponentMovementWatcher()

juce::ComponentMovementWatcher::~ComponentMovementWatcher | ( |  | ) |

override

Destructor.

## Member Functions

## componentMovedOrResized() [1/2]

virtual void juce::ComponentMovementWatcher::componentMovedOrResized | ( | bool | wasMoved,
|  | bool | wasResized )

pure virtual

This callback happens when the component that is being watched is moved relative to its top-level peer window, or when it is resized.

## componentPeerChanged()

virtual void juce::ComponentMovementWatcher::componentPeerChanged | ( |  | ) |

pure virtual

This callback happens when the component's top-level peer is changed.

## componentVisibilityChanged() [1/2]

virtual void juce::ComponentMovementWatcher::componentVisibilityChanged | ( |  | ) |

pure virtual

This callback happens when the component's visibility state changes, possibly due to one of its parents being made visible or invisible.

Referenced by juce::NativeScaleFactorNotifier::~NativeScaleFactorNotifier().

## getComponent()

Component * juce::ComponentMovementWatcher::getComponent | ( |  | ) | const

inline noexcept

Returns the component that's being watched.

## componentParentHierarchyChanged()

void juce::ComponentMovementWatcher::componentParentHierarchyChanged | ( | Component & | component | ) |

override virtual

Called to indicate that the component's parents have changed.

When a component is added or removed from its parent, all of its children will produce this notification (recursively - so all children of its children will also be called as well).

Parameters

  component | the component that this listener is registered with

See also
  Component::parentHierarchyChanged

Reimplemented from juce::ComponentListener.

## componentMovedOrResized() [2/2]

void juce::ComponentMovementWatcher::componentMovedOrResized | ( | Component & | component,
|  | bool | wasMoved,
|  | bool | wasResized )

override virtual

Called when the component's position or size changes.

Parameters

  component | the component that was moved or resized
  wasMoved | true if the component's top-left corner has just moved
  wasResized | true if the component's width or height has just changed

See also
  Component::setBounds, Component::resized, Component::moved

Reimplemented from juce::ComponentListener.

## componentBeingDeleted()

void juce::ComponentMovementWatcher::componentBeingDeleted | ( | Component & | component | ) |

override virtual

Called when the component is in the process of being deleted.

This callback is made from inside the destructor, so be very, very cautious about what you do in here.

In particular, bear in mind that it's the Component base class's destructor that calls this - so if the object that's being deleted is a subclass of Component, then the subclass layers of the object will already have been destructed when it gets to this point!

Parameters

  component | the component that was deleted

Reimplemented from juce::ComponentListener.

## componentVisibilityChanged() [2/2]

void juce::ComponentMovementWatcher::componentVisibilityChanged | ( | Component & | component | ) |

override virtual

Called when the component is made visible or invisible.

Parameters

  component | the component that changed

See also
  Component::setVisible

Reimplemented from juce::ComponentListener.

References ComponentMovementWatcher().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited